// BioTestClientDlg.cpp : implementation file
// Copyright (c) 2007 Sam C. Lin  ALL RIGHTS RESERVED

#include "stdafx.h"
#include "BETestClientDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define MAX_FILE_CNT 100


typedef struct filespec {
  FILE *m_fp;
  char fn[MAX_PATH];
} FILESPEC,*PFILESPEC;

int g_iMaxFileCnt;
PFILESPEC g_Files;
char g_sDate[80];


void CloseFiles()
{
  for (int i=0;i < g_iMaxFileCnt;i++) {
    if (g_Files[i].m_fp) {
      fflush(g_Files[i].m_fp);
      fclose(g_Files[i].m_fp);
    }
  }
}


/////////////////////////////////////////////////////////////////////////////
// CBETestClientDlg dialog

CBETestClientDlg::CBETestClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBETestClientDlg::IDD, pParent)
{
  *m_sOutputDir = 0;
  m_iOutType = OUT_TYPE_TEXT;
  g_iMaxFileCnt = MAX_FILE_CNT;
  g_Files = new FILESPEC[g_iMaxFileCnt];
  ZeroMemory(g_Files,sizeof(FILESPEC)*g_iMaxFileCnt);

	//{{AFX_DATA_INIT(CBETestClientDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_pClient = NULL;
	m_fRedraw = FALSE;
}

CBETestClientDlg::~CBETestClientDlg()
{
  CloseFiles();
  if (g_Files) {
    delete [] g_Files;
  }
}

void CBETestClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBETestClientDlg)
	DDX_Control(pDX, IDC_EDT_OUTDIR, m_edtOutDir);
	DDX_Control(pDX, IDC_CONNECTED_TO, m_ConnectedToStatic);
	DDX_Control(pDX, IDC_SERVER, m_ServerCombo);
	DDX_Control(pDX, IDC_AUTO_CONNECT, m_AutoConnectButton);
	DDX_Control(pDX, IDC_BAR_STATIC, m_BarStatic);
	DDX_Control(pDX, IDC_STATUS, m_StatusEdit);
	DDX_Control(pDX, IDC_OUT_TEXT, m_BtnTextOut);
	DDX_Control(pDX, IDC_OUT_BINARY, m_BtnBinaryOut);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBETestClientDlg, CDialog)
	//{{AFX_MSG_MAP(CBETestClientDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	ON_BN_CLICKED(IDC_AUTO_CONNECT, OnAutoConnect)
	ON_BN_CLICKED(IDC_OUT_BINARY, OnOutBinary)
	ON_BN_CLICKED(IDC_OUT_TEXT, OnOutText)
	ON_WM_SYSCOMMAND()
	ON_BN_CLICKED(IDC_BTN_SETDIR, OnBtnSetdir)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CBETestClientDlg::ResizeBars()
{
	if( m_BarArray.GetSize() > 0 )
	{
		CRect rc;
		m_BarStatic.GetWindowRect( rc );
		ScreenToClient( rc );
		rc.DeflateRect( 3, 3 );

		double x = rc.left;
		double step = (double)rc.Width() / (double)m_BarArray.GetSize();

		for( int i=0; i<m_BarArray.GetSize(); i++ )
		{
			m_BarArray[i]->rcBar.top = rc.top;
			m_BarArray[i]->rcBar.bottom = rc.bottom - m_LabelHeight;
			m_BarArray[i]->rcBar.left = (int)x;
			m_BarArray[i]->rcBar.right = (int)( x + step );

			m_BarArray[i]->rcBar.DeflateRect( 2, 0 );

			m_BarArray[i]->rcLabel.top = rc.bottom - m_LabelHeight;
			m_BarArray[i]->rcLabel.bottom = rc.bottom;
			m_BarArray[i]->rcLabel.left = (int)x;
			m_BarArray[i]->rcLabel.right = (int)( x + step );

			m_BarArray[i]->rcLabel.DeflateRect( 2, 0 );

			x += step;
		}
	}

	Invalidate();
}

BOOL CBETestClientDlg::RenderBars( CDC *pDC )
{
	if( NULL == pDC )
	{
		return ( FALSE );
	}

	pDC->SetBkMode( TRANSPARENT );
	pDC->SetTextColor( COLORREF( 0x00ff0000 ) );

	CFont *pOldFont = pDC->SelectObject( &m_LabelFont );

	int y;
	double Percent;

	for( int i=0; i<m_BarArray.GetSize(); i++ )
	{
		Percent = ( m_BarArray[i]->Value - 0.0 ) / ( 0.00006 - 0.0 );
		y = (int)( Percent * (double)m_BarArray[i]->rcBar.Height() );
		y = m_BarArray[i]->rcBar.bottom - y;
		y = min( y, m_BarArray[i]->rcBar.bottom );
		y = max( y, m_BarArray[i]->rcBar.top );

		pDC->FillSolidRect(
			m_BarArray[i]->rcBar.left,
			m_BarArray[i]->rcBar.top,
			m_BarArray[i]->rcBar.Width(),
			y - m_BarArray[i]->rcBar.top,
			COLORREF( 0x00000000 ) );

		pDC->FillSolidRect(
			m_BarArray[i]->rcBar.left,
			y,
			m_BarArray[i]->rcBar.Width(),
			m_BarArray[i]->rcBar.bottom - y,
			COLORREF( 0x00ff0000 ) );

		pDC->Draw3dRect( m_BarArray[i]->rcLabel, GetSysColor( COLOR_3DHILIGHT ), GetSysColor( COLOR_3DSHADOW ) );
		pDC->DrawText( m_BarArray[i]->Name, m_BarArray[i]->rcLabel, DT_CENTER | DT_VCENTER | DT_SINGLELINE | DT_END_ELLIPSIS );
	}

	pDC->SelectObject( pOldFont );

	m_fRedraw = FALSE;

	return ( TRUE );
}


/////////////////////////////////////////////////////////////////////////////
// CBETestClientDlg message handlers

int CBETestClientDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
	{
		return -1;
	}

	CoInitialize( NULL );

	TCHAR szTemp[200];
	HRESULT hr;

	//
	// Create and initialize our client object
	//
	if( FAILED( hr = CoCreateInstance(
		CLSID_CBEClient,
		NULL,
		CLSCTX_INPROC_SERVER,
		IID_IBEClient,
		(void **)&m_pClient ) ) )
	{
		wsprintf( szTemp, "Failed to create Client object: %08x", hr );
		AfxMessageBox( szTemp );
		return ( -1 );
	}

//	m_pClient->ShowLogWindow( TRUE );

	if( FAILED( hr = m_pClient->Initialize() ) )
	{
		wsprintf( szTemp, "Client Initialization failed: %08x", hr );
		AfxMessageBox( szTemp );
		return ( -1 );
	}

	m_pClient->SetAutoConnect( FALSE );

	m_LabelFont.CreatePointFont( 80, "Tahoma" );

	CDC *pDC = GetDC();
	CFont *pOldFont = pDC->SelectObject( &m_LabelFont );

	m_LabelHeight = pDC->GetTextExtent( "Ag", 2 ).cy;
	m_LabelHeight = (int)( m_LabelHeight * 1.5 );

	pDC->SelectObject( pOldFont );
	ReleaseDC( pDC );

	SetTimer( 1, 30, NULL );

	return 0;
}

void CBETestClientDlg::OnDestroy() 
{
	KillTimer( 1 );

	if( NULL != m_pClient )
	{
		m_pClient->UnMonitor( (IBEClientMonitor *)this );
		m_pClient->Shutdown();
		m_pClient->Release();
	}

	m_IDBarInfoMap.RemoveAll();

	for( int i=0; i<m_BarArray.GetSize(); i++ )
	{
		delete m_BarArray[i];
	}

	m_BarArray.RemoveAll();

	CoUninitialize();

	CDialog::OnDestroy();
}

BOOL CBETestClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	GetCurrentDirectory(MAX_PATH,m_sOutputDir);
	m_edtOutDir.SetWindowText(m_sOutputDir);

	if (m_iOutType == OUT_TYPE_TEXT)
	  m_BtnTextOut.SetCheck(BST_CHECKED);
	else
	  m_BtnBinaryOut.SetCheck(BST_CHECKED);

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_BarStatic.ShowWindow( SW_HIDE );

	m_pClient->Monitor( (IBEClientMonitor *)this, 1 );

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBETestClientDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	if (IsIconic())
	{
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);

		return;
	}

	RenderBars( &dc );
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBETestClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBETestClientDlg::OnTimer(UINT nIDEvent) 
{
	if( m_fRedraw )
	{
		CDC *pDC = GetDC();
		RenderBars( pDC );
		ReleaseDC( pDC );
	}
}


//
// Connect button handler
//
void CBETestClientDlg::OnConnect() 
{
	//
	// If we're already connected do nothing
	//
	if( NOERROR == m_pClient->IsConnected() )
	{
		m_StatusEdit.ReplaceSel( "Already connected or connecting\r\n" );
		m_StatusEdit.LineScroll( 1000000 );
		return;
	}

	//
	// Get the server name/address
	//
	CString String;
	m_ServerCombo.GetWindowText( String );

	if( String.IsEmpty() )
	{
		return;
	}

	m_StatusEdit.SetSel( -1, -1 );
	m_StatusEdit.ReplaceSel( "Attempting connection to " );
	m_StatusEdit.ReplaceSel( String );
	m_StatusEdit.ReplaceSel( "...\r\n" );
	m_StatusEdit.LineScroll( 1000000 );

	//
	// Connect
	//
	HRESULT hr = m_pClient->Connect( String );

}

//
// Disconnect button handler
//
void CBETestClientDlg::OnDisconnect() 
{
	m_StatusEdit.SetSel( -1, -1 );
	m_StatusEdit.ReplaceSel( "Disconnecting...\r\n" );
	m_StatusEdit.LineScroll( 1000000 );
	CloseFiles();

	if( NOERROR != m_pClient->IsConnected() )
	{
		m_StatusEdit.ReplaceSel( "Not connected\r\n" );
		m_StatusEdit.LineScroll( 1000000 );
	}
	else
	{
		HRESULT hr = m_pClient->Disconnect();
	}
}

//
// Auto connect button handler
//
void CBETestClientDlg::OnAutoConnect() 
{
	m_pClient->SetAutoConnect( m_AutoConnectButton.GetCheck() == BST_CHECKED );
}






//
// IBEClientMonitor callback handler functions
//
void CBETestClientDlg::OnServerAdded( DWORD dwContext, const char *pszAddress )
{
	if( NULL == pszAddress )
	{
		return;
	}

	m_StatusEdit.SetSel( -1, -1 );
	m_StatusEdit.ReplaceSel( "Server added: " );
	m_StatusEdit.ReplaceSel( pszAddress );
	m_StatusEdit.ReplaceSel( "\r\n" );
	m_StatusEdit.LineScroll( 1000000 );

	//
	// Make sure we don't already have this server in the list
	//
	CString String;

	for( int i=0; i<m_ServerCombo.GetCount(); i++ )
	{
		m_ServerCombo.GetLBText( i, String );

		if( String == pszAddress )
		{
			return;
		}
	}

	//
	// Add it to the list
	//
	int iItem = m_ServerCombo.AddString( pszAddress );

	m_ServerCombo.GetWindowText( String );

	if( String.IsEmpty() && m_ServerCombo.GetCount() == 1 )
	{
		m_ServerCombo.SetCurSel( 0 );
	}
}

void CBETestClientDlg::OnServerRemoved( DWORD dwContext, const char *pszAddress )
{
	if( NULL == pszAddress )
	{
		return;
	}

	m_StatusEdit.SetSel( -1, -1 );
	m_StatusEdit.ReplaceSel( "Server removed: " );
	m_StatusEdit.ReplaceSel( pszAddress );
	m_StatusEdit.ReplaceSel( "\r\n" );
	m_StatusEdit.LineScroll( 1000000 );

	//
	// Remove this server from the list
	//
	int iItem = m_ServerCombo.FindStringExact( -1, pszAddress );

	if( CB_ERR != iItem )
	{
		m_ServerCombo.DeleteString( iItem );
		m_ServerCombo.Invalidate();
	}
}

void CBETestClientDlg::OnConnect( DWORD Context, const char * pszAddress, HRESULT hr )
{
	m_StatusEdit.SetSel( -1, -1 );

	if( SUCCEEDED( hr ) )
	{
		m_StatusEdit.ReplaceSel( "Connected\r\n" );
		m_ConnectedToStatic.SetWindowText( pszAddress );

	SYSTEMTIME st;
	GetLocalTime(&st);
	sprintf(g_sDate,"%04d%02d%02d_%02d%02d%02d",st.wYear,st.wMonth,
			st.wDay,st.wHour,st.wMinute,st.wSecond);


	}
	else
	{
		TCHAR szTemp[100];
		wsprintf( szTemp, "Connection failed: 0x%08x\r\n", hr );
		m_StatusEdit.ReplaceSel( szTemp );
	}

	m_StatusEdit.LineScroll( 1000000 );
}

void CBETestClientDlg::OnDisconnect( DWORD Context )
{
	m_StatusEdit.SetSel( -1, -1 );
	m_StatusEdit.ReplaceSel( "Disconnected\r\n" );
	m_StatusEdit.LineScroll( 1000000 );

	m_IDBarInfoMap.RemoveAll();

	for( int i=0; i<m_BarArray.GetSize(); i++ )
	{
		delete m_BarArray[i];
	}

	m_BarArray.RemoveAll();

	Invalidate();
	m_ConnectedToStatic.SetWindowText( "" );
}

void CBETestClientDlg::OnChannelAdded( DWORD Context, DWORD ChannelID, const char *pszName, double SampleRate )
{
	TCHAR szTemp[1000];
	_stprintf( szTemp, "Channel Added: %d  %s  %0.1f\r\n", ChannelID, pszName, SampleRate );

	m_StatusEdit.SetSel( -1, -1 );
	m_StatusEdit.ReplaceSel( szTemp );
	m_StatusEdit.LineScroll( 1000000 );

	BarInfo *pbi = new BarInfo;

	pbi->Name = pszName;
	pbi->ID = ChannelID;

	m_BarArray.Add( pbi );

	m_IDBarInfoMap.SetAt( (void *)ChannelID, pbi );
	if (ChannelID < g_iMaxFileCnt) {
	  PFILESPEC pfs = g_Files + ChannelID;
	  m_edtOutDir.GetWindowText(m_sOutputDir,MAX_PATH);
	  if (m_sOutputDir[lstrlen(m_sOutputDir)-1] != '\\') {
	    lstrcat(m_sOutputDir,"\\");
	  }
	  sprintf(pfs->fn,"%s,%d-%s-%0.1lf-%s.txt",m_sOutputDir,ChannelID,pszName,SampleRate,g_sDate);
	  if (pfs->m_fp) {
	    fflush(pfs->m_fp);
	    fclose(pfs->m_fp);
	  }
	  pfs->m_fp = fopen(pfs->fn,(m_iOutType == OUT_TYPE_TEXT) ? "w" : "wb");
	  if (pfs->m_fp) {
	    sprintf(szTemp,"Opened file:");
	  }
	  else {
	    sprintf(szTemp,"Error opening file:");
	  }
	  strcat(szTemp," ");
	  strcat(szTemp,pfs->fn);
	  strcat(szTemp,"\r\n");

	  m_StatusEdit.SetSel( -1, -1 );
	  m_StatusEdit.ReplaceSel(szTemp);
	  m_StatusEdit.LineScroll( 1000000 );
	}

	ResizeBars();
}

void CBETestClientDlg::OnChannelRemoved( DWORD Context, DWORD ChannelID )
{
	TCHAR szTemp[1000];
	_stprintf( szTemp, "Channel Removed: %d\r\n", ChannelID );

	m_StatusEdit.SetSel( -1, -1 );
	m_StatusEdit.ReplaceSel( szTemp );
	m_StatusEdit.LineScroll( 1000000 );

	m_IDBarInfoMap.RemoveKey( (void *)ChannelID );

	for( int i=0; i<m_BarArray.GetSize(); i++ )
	{
		if( m_BarArray[i]->ID == ChannelID )
		{
			delete m_BarArray[i];
			m_BarArray.RemoveAt( i );
			ResizeBars();
			break;
		}
	}
}

void CBETestClientDlg::OnChannelNameChanged( DWORD Context, DWORD ChannelID, const char *pszName )
{
	TCHAR szTemp[1000];
	_stprintf( szTemp, "Channel Name Changed: %d  %s\r\n", ChannelID, pszName );

	m_StatusEdit.SetSel( -1, -1 );
	m_StatusEdit.ReplaceSel( szTemp );
	m_StatusEdit.LineScroll( 1000000 );

	void *pv;

	if( !m_IDBarInfoMap.Lookup( (void *)ChannelID, pv ) )
	{
		return;
	}

	BarInfo *pi = (BarInfo *)pv;

	pi->Name = pszName;

	InvalidateRect( pi->rcLabel );
}

void CBETestClientDlg::OnChannelSampleRateChanged( DWORD Context, DWORD ChannelID, double SampleRate )
{
	TCHAR szTemp[1000];
	_stprintf( szTemp, "Channel Sample Rate Changed: %d  %0.1f\r\n", ChannelID, SampleRate );

	m_StatusEdit.SetSel( -1, -1 );
	m_StatusEdit.ReplaceSel( szTemp );
	m_StatusEdit.LineScroll( 1000000 );
}

void CBETestClientDlg::OnChannelSamples( DWORD Context, DWORD ChannelID, double *pSamples, DWORD cSamples )
{
	if( ( NULL == pSamples ) || ( 0 == cSamples ) )
	{
		return;
	}

	void *pv;

	if ((ChannelID < g_iMaxFileCnt) && g_Files[ChannelID].m_fp) {
	  //	  fwrite(pSamples,sizeof(double),cSamples,m_Ofp);

	  PFILESPEC pfs = g_Files + ChannelID;
	  if (m_iOutType == OUT_TYPE_TEXT) {
	    for (int i=0;i < cSamples;i++) {
	      fprintf(pfs->m_fp,"%le\n",pSamples[i]);
	    }
	  }
	  else {
	    fwrite(pSamples,sizeof(*pSamples),cSamples,pfs->m_fp);
	  }
	}

	if( !m_IDBarInfoMap.Lookup( (void *)ChannelID, pv ) )
	{
		return;
	}

	BarInfo *pi = (BarInfo *)pv;

	pi->Value = pSamples[cSamples-1];
	m_fRedraw = TRUE;
}

void CBETestClientDlg::OnPlay( DWORD Context )
{
	m_StatusEdit.SetSel( -1, -1 );
	m_StatusEdit.ReplaceSel( "Playing\r\n" );
	m_StatusEdit.LineScroll( 1000000 );
}

void CBETestClientDlg::OnPause( DWORD Context )
{
	m_StatusEdit.SetSel( -1, -1 );
	m_StatusEdit.ReplaceSel( "Paused\r\n" );
	m_StatusEdit.LineScroll( 1000000 );
}

void CBETestClientDlg::OnStop( DWORD Context )
{
	m_StatusEdit.SetSel( -1, -1 );
	m_StatusEdit.ReplaceSel( "Stopped\r\n" );
	m_StatusEdit.LineScroll( 1000000 );

	for( int i=0; i<m_BarArray.GetSize(); i++ )
	{
		m_BarArray[i]->Value = 0.0;
	}

	Invalidate();
}



void CBETestClientDlg::OnOutBinary() 
{
  m_iOutType = OUT_TYPE_BINARY;
  ASSERT(m_BtnBinaryOut.GetCheck() & BST_CHECKED);
}

void CBETestClientDlg::OnOutText() 
{
  m_iOutType = OUT_TYPE_TEXT;
  ASSERT(m_BtnTextOut.GetCheck() & BST_CHECKED);
}

void CBETestClientDlg::OnBtnSetdir() 
{
BROWSEINFO bi = { 0 };
    bi.lpszTitle = _T("Pick a Directory");
    LPITEMIDLIST pidl = SHBrowseForFolder ( &bi );
    if ( pidl != 0 )
    {
        // get the name of the folder
        TCHAR path[MAX_PATH];
        if ( SHGetPathFromIDList ( pidl, path ) )
        {
            m_edtOutDir.SetWindowText(path);
        }

        // free memory used
        IMalloc * imalloc = 0;
        if ( SUCCEEDED( SHGetMalloc ( &imalloc )) )
        {
            imalloc->Free ( pidl );
            imalloc->Release ( );
        }
    }
	
}
