// BETestClientDlg.h : header file
//

#if !defined(AFX_BETESTCLIENTDLG_H__3495110B_3E5A_4616_8D04_7A550C165D32__INCLUDED_)
#define AFX_BETESTCLIENTDLG_H__3495110B_3E5A_4616_8D04_7A550C165D32__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "c:\program files\bioexplorer\code\include\BEClientInterface.h"
#include "resource.h"
#include <afxtempl.h>

#define OUT_TYPE_TEXT 0
#define OUT_TYPE_BINARY 1

/////////////////////////////////////////////////////////////////////////////
// CBETestClientDlg dialog

class CBETestClientDlg : public CDialog, public IBEClientMonitor
{
  FILE *m_Ofp;
  int m_iOutType;
  char m_sOutputDir[MAX_PATH];

// Construction
public:
	CBETestClientDlg(CWnd* pParent = NULL);	// standard constructor
	~CBETestClientDlg();

	//
	// IBEClientMonitor
	//
	virtual void OnServerAdded( DWORD Context, const char * pszAddress );
	virtual void OnServerRemoved( DWORD Context, const char * pszAddress );
	virtual void OnConnect( DWORD Context, const char * pszAddress, HRESULT hr );
	virtual void OnDisconnect( DWORD Context );
	virtual void OnChannelAdded( DWORD Context, DWORD ChannelID, const char * pszName, double SampleRate );
	virtual void OnChannelRemoved( DWORD Context, DWORD ChannelID );
	virtual void OnChannelNameChanged( DWORD Context, DWORD ChannelID, const char * pszName );
	virtual void OnChannelSampleRateChanged( DWORD Context, DWORD ChannelID, double SampleRate );
	virtual void OnChannelSamples( DWORD Context, DWORD ChannelID, double *pSamples, DWORD cSamples );
	virtual void OnPlay( DWORD Context );
	virtual void OnPause( DWORD Context );
	virtual void OnStop( DWORD Context );

// Dialog Data
	//{{AFX_DATA(CBETestClientDlg)
	enum { IDD = IDD_BETESTCLIENT_DIALOG };
	CEdit	m_edtOutDir;
	CStatic	m_ConnectedToStatic;
	CComboBox	m_ServerCombo;
	CButton	m_AutoConnectButton;
	CStatic	m_BarStatic;
	CRichEditCtrl	m_StatusEdit;
	CButton m_BtnTextOut;
	CButton m_BtnBinaryOut;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBETestClientDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void ResizeBars();
	BOOL RenderBars( CDC *pDC );

	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CBETestClientDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnConnect();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDisconnect();
	afx_msg void OnAutoConnect();
	afx_msg void OnOutBinary();
	afx_msg void OnOutText();
	afx_msg void OnBtnSetdir();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	IBEClient				*m_pClient;
	BOOL					m_fRedraw;
	CFont					m_LabelFont;
	int						m_LabelHeight;

	struct BarInfo
	{
		DWORD ID;
		CString Name;
		CRect rcBar;
		CRect rcLabel;
		double Value;

		BarInfo()
		{
			ID = 0;
			Value = 0.0;
		}
	};

	CArray < BarInfo *, BarInfo * >		m_BarArray;
	CMapPtrToPtr						m_IDBarInfoMap;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BETESTCLIENTDLG_H__3495110B_3E5A_4616_8D04_7A550C165D32__INCLUDED_)
